<script>
  import {scaleBand, scaleLinear} from "d3-scale";
  import {axisBottom, axisLeft} from "d3-axis";
  import {select} from "d3-selection";
  
  // Dimensions
  const width = 600;
  const height = 300;
  const margin = { top: 10, right: 10, bottom: 30, left: 60 };
  const innerWidth = width - margin.left - margin.right;
  const innerHeight = height - margin.top - margin.bottom;

  // Array
  const data = [
    { service: "Netflix", viewers: 2.9 },
    { service: "Amazon Prime Video", viewers: 1.3 },
    { service: "Disney+", viewers: 2.1 },
    { service: "Hulu", viewers: 0.9 },
    { service: "Apple TV", viewers: 1.1 },
    { service: "Rakuten", viewers: 0.4 }
  ];
   const arrayX = ["Netfilx", "Amazon Prime Video", "Disney+", "Hulu", "Apple TV", "Rakuten"];
   const scaleX = scaleBand().domain(["Nextfilx", "Amazon Prime Video", "Disney+", "Hulu", "Apple TV", "Rakuten"]).range([-17,innerWidth]).padding(0.2);
   const scaleYY = scaleLinear().domain([0,3]).range([0,innerHeight]);
   const scaleY = scaleLinear().domain([0,3]).range([innerHeight,0]);
   function xAxis(element) {
      const x_axis = axisBottom(scaleX);
            x_axis(select(element));

   };
   function yAxis(element) {
      const y_axis = axisLeft(scaleY);
            y_axis(select(element));
   };
</script>

<!-- setting a viewBox and max-width allows the SVG to shrink but not grow! -->
<svg viewbox="0 0 {width} {height}" style="max-width: {width}px">
  <g transform={`translate(${margin.left},${margin.top})`}>
    {#each data as d}
      <rect x={scaleX(d.service)} 
            y={260-scaleYY(d.viewers)}
            width = {scaleX.bandwidth()}
            height = {scaleYY(d.viewers)}
            fill= "steelblue"/>
    {/each}
    
    <g use:xAxis transform="translate(0,260)">
    </g>
    <g use:yAxis transform="translate(-17,0)">
    </g>
    <text x=50, y=-170 transform=rotate(-180)>Viewers (Million)</text>

    

  </g>
</svg>

<style>
  text {
    writing-mode: vertical-lr;
    text-orientation: mixed;
    font-size: x-small;
    font-weight: 20;
    fill: currentColor;
  }
</style>
